<?php
/*
      Plugin Name: Facebook Revised Open Graph Meta Tag
      Plugin URI: http://thecodep0et.com/facebook-revised-open-graph-meta-tag-plugin/
      Description: Adds automatically the meta tags required by Facebook to your pages, posts, homepage.
      Version: 0.2
      Author: TheCodeP0et
      Author URI: http://thecodep0et.com/
*/
// Part of this code is based


function fbrogmt() {
	if(is_single() ){ // Post
		if (have_posts()) : while (have_posts()) : the_post(); 

		$meta[]=get_the_title($post->post_title);// Gets the title
			$meta[]=get_permalink();// gets the url of the post
			$meta[]=get_the_image();//Gets the first image of a post/page if there is one
			$meta[]=get_option('blogname');//Site name
			$meta[]= the_excerpt_max_charlength(300) . '...'; //Description comes from the excerpt, because by using the_content, it will dish out the [caption id...]
		endwhile; endif; 
	}
	elseif(is_page() ){ // Page
		if (have_posts()) : while (have_posts()) : the_post(); 
			$meta[]=get_the_title($post->post_title);// Gets the title
			$meta[]=get_permalink();// gets the url of the post
			$meta[]=get_the_image();//Gets the first image of a post/page if there is one
			$meta[]=get_option('blogname');//Site name
			$meta[]= the_excerpt_max_charlength(300) . '...' ;  //Description comes from the excerpt, because by using the_content, it will dish out the [caption id...]
		endwhile; endif; 
	}
	
	else{
		
		$meta[]=get_option('blogname');//Title
		$meta[]=get_option('siteurl');//URL
		$meta[]= get_bloginfo('template_directory') . "/images/facebook-default.jpg";
		$meta[]=get_option('blogname');//Site name
		$meta[]=get_option('blogdescription');//Description
	}
	
	echo tags($meta);
}

/* Output of the meta tags */
function tags($meta){

	$tag.="<meta property='og:title' content='".$meta[0]."'/>\n"; 
	$tag.="<meta property='og:url' content='".$meta[1]."'/>\n";
	$tag.="<meta property='og:image' content='".$meta[2]."'/>\n";
	$tag.="<meta property='og:site_name' content='".$meta[3]."'/>\n";
	$tag.="<meta property=\"og:description\" content=\"$meta[4]\"/>\n";
	return $tag;
}


/* Get the first image of a post */
function get_the_image() {
  global $post, $posts;
  $first_img = '';
  ob_start();
  ob_end_clean();
  $output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
  $first_img = $matches [1] [0];

  if(empty($first_img)){ //Defines a default image
    $first_img = get_bloginfo('template_directory') . "/images/facebook-default.jpg";
  }
  return $first_img;
}



/* Extracts the content, removes tags, cuts it, removes the caption shortcode */

function the_excerpt_max_charlength($charlength) {
$content = get_the_content(); //get the content
$content = strip_tags($content); // strip all html tags
$regex = "#([[]caption)(.*)([[]/caption[]])#e"; // the regex to remove the caption shortcude tag
$content = preg_replace($regex,'',$content); // remove the caption shortcude tag
$content = preg_replace( '/\r\n/', ' ', trim($content) ); // remove all new lines
   $excerpt = $content;
   $charlength++;
   if(strlen($excerpt)>$charlength) {
       $subex = substr($excerpt,0,$charlength-5);
       $exwords = explode(" ",$subex);
       $excut = -(strlen($exwords[count($exwords)-1]));
       if($excut<0) {
            return substr($subex,0,$excut);
       } else {
            return $subex;
       }
       return "[...]";
   } else {
    return $excerpt;
   }
}


//Add the meta tags to wp_head 
add_action('wp_head', 'fbrogmt');
?>